// FileEditorDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "FileEditor.h"
#include "FileEditorDlg.h"
#include "Hyperlink.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CWnd* www = GetDlgItem(IDC_WWW);

	www->GetDC()->SetTextColor(RGB(0,0,255));
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileEditorDlg Dialogfeld

CFileEditorDlg::CFileEditorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileEditorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileEditorDlg)
	isArchive = FALSE;
	accessDate = 0;
	accessTime = 0;
	changedDate = 0;
	changedTime = 0;
	createDate = 0;
	createTime = 0;
	filename = _T("");
	filePath = _T("");
	isHidden = FALSE;
	isReadOnly = FALSE;
	isSystem = FALSE;
	fileSize = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	commandLine = false;
	initialized = false;
}

void CFileEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileEditorDlg)
	DDX_Check(pDX, IDC_ARCHIVE, isArchive);
	DDX_DateTimeCtrl(pDX, IDC_DAT_ACCESS_DATE, accessDate);
	DDX_DateTimeCtrl(pDX, IDC_DAT_ACCESS_TIME, accessTime);
	DDX_DateTimeCtrl(pDX, IDC_DAT_CHANGED_DATE, changedDate);
	DDX_DateTimeCtrl(pDX, IDC_DAT_CHANGED_TIME, changedTime);
	DDX_DateTimeCtrl(pDX, IDC_DAT_CREATE_DATE, createDate);
	DDX_DateTimeCtrl(pDX, IDC_DAT_CREATE_TIME, createTime);
	DDX_Text(pDX, IDC_FILE_NAME, filename);
	DDX_Text(pDX, IDC_FILE_PATH, filePath);
	DDX_Check(pDX, IDC_HIDDEN, isHidden);
	DDX_Check(pDX, IDC_READONLY, isReadOnly);
	DDX_Check(pDX, IDC_SYSTEM, isSystem);
	DDX_Text(pDX, IDC_FILE_SIZE, fileSize);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileEditorDlg, CDialog)
	ON_WM_DROPFILES()
	//{{AFX_MSG_MAP(CFileEditorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()

	ON_BN_CLICKED(IDC_FILE_ICON, OnIconClick)
	ON_BN_CLICKED(IDC_OPEN_FILE, OnOpenFile)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_CLOSE, OnOK)
	ON_BN_CLICKED(IDC_INFO, OnIconClick)
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileEditorDlg Nachrichten-Handler

BOOL CFileEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	initialized = true;

	if (commandLine)
	{
			/*file.Open(filePath,CFile::modeRead);

		filePath = file.GetFilePath();

		file.Close();*/

		Open(filePath);
	}

	//Dateien akzeptieren

	DragAcceptFiles();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CFileEditorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CFileEditorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CFileEditorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFileEditorDlg::OnIconClick() 
{
	CAboutDlg aboutDlg;

	aboutDlg.DoModal();
}

void CFileEditorDlg::OnOpenFile() 
{
	CFileDialog fileDialog(true,NULL,NULL,OFN_OVERWRITEPROMPT,"Alle Dateien (*.*) |*.*|", this );

	if (fileDialog.DoModal() == IDOK)
	{
		Open(fileDialog.GetPathName());
	}

	
}

void CFileEditorDlg::Update()
{
	filename = file.getFilename();
	filePath = file.getPath();
	
	CString string;

	//Dateigrsse formatieren

	int sizeOfFile = file.getSize();
	
	if (sizeOfFile > (1024*1024))
	{
		string.Format("%.3f MBytes (%d Bytes)",(sizeOfFile ? float(sizeOfFile)/1024.0f/1024.0f : 000),
		sizeOfFile);
	}
	else
	{
		
		string.Format("%.2f KBytes (%d Bytes)",(sizeOfFile ? float(sizeOfFile)/1024.0f : 000),
		sizeOfFile);
	}

	fileSize = string;

	isArchive = file.getArchive();
	isReadOnly = file.getReadOnly();
	isSystem = file.getSystem();
	isHidden = file.getHidden();

	accessDate = file.getLastAccessTime();
	accessTime = file.getLastAccessTime();
	changedDate = file.getModifyTime();
	changedTime = file.getModifyTime();
	createDate = file.getCreationTime();
	createTime = file.getCreationTime();

	UpdateData(false);
}

void CFileEditorDlg::OnOK() 
{
	CDialog::OnOK();	
}

void CFileEditorDlg::OnSave() 
{
	UpdateData();
	
	file.setArchive(isArchive);
	file.setReadOnly(isReadOnly);
	file.setSystem(isSystem);
	file.setHidden(isHidden);

	CTime access(accessDate.GetYear(),accessDate.GetMonth(),accessDate.GetDay(),
		accessTime.GetHour(),accessTime.GetMinute(),accessTime.GetSecond());
	file.setLastAccessTime(access);

	CTime creation(createDate.GetYear(),createDate.GetMonth(),createDate.GetDay(),
		createTime.GetHour(),createTime.GetMinute(),createTime.GetSecond());
	file.setCreationTime(creation);

	CTime modify(changedDate.GetYear(),changedDate.GetMonth(),changedDate.GetDay(),
		changedTime.GetHour(),changedTime.GetMinute(),changedTime.GetSecond());
	file.setModifyTime(modify);
	
	file.setFilename(filename);
	
	file.save();
}



void CFileEditorDlg::Open(CString fullPath)
{
	CString string;

	if (!initialized)
	{
		filePath = fullPath;
		commandLine = true;
		
		return;
	}

	
	//Dateinamen extrahieren
	for (int i = fullPath.GetLength()-1; i >= 0; i -= 1)
	{
		string += fullPath[i];

		if (fullPath[i] == '\\')
		{
			//String umdrehen
			//(wurde vorher von hinten nach vorne
			//gelesen
			string.Replace('\\','\0');
			string.MakeReverse();
			break;
		}
	}
	



	if (!file.open(fullPath,string))
	{
		CString string;

		string.Format("Die Datei %s konnte nicht geffnet werden.\n"
			"Bitte berprfen Sie die Pfadangabe.",
			fullPath);
		MessageBox(string,"Fehler",
					MB_OK | MB_ICONSTOP);
	}
	else
	{
		Update();
	}
}

void CFileEditorDlg::OnDropFiles(HDROP dropInfo)
{
	char buffer[256];
	CString string;

	DragQueryFile(dropInfo,0,buffer,256);

	string = buffer;

	if (!string.IsEmpty())
	{
		Open(string);
	}
}

