// FileInformation.h: Schnittstelle fr die Klasse CFileInformation.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEINFORMATION_H__371601EF_36B4_11D5_AF7E_0050DA829896__INCLUDED_)
#define AFX_FILEINFORMATION_H__371601EF_36B4_11D5_AF7E_0050DA829896__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"

class CFileInformation  
{
public:
	CString getPath();
	int getSize();
	CTime getModifyTime();
	CTime getLastAccessTime();
	CTime getCreationTime();
	CString getFilename();
	bool getSystem();
	bool getReadOnly();
	bool getHidden();
	bool getArchive();
	void save();
	void setModifyTime(CTime time);
	void setLastAccessTime(CTime time);
	void setCreationTime(CTime time);
	void setArchive(bool);
	void setSystem(bool);
	void setHidden(bool);
	void setReadOnly(bool);
	void setFilename(CString filename);
	bool open(CString path, CString filename);
	CFileInformation();
	virtual ~CFileInformation();
protected:
	CFileStatus fileStatus;
	CString fileName;
	CString fullPath;

};

#endif // !defined(AFX_FILEINFORMATION_H__371601EF_36B4_11D5_AF7E_0050DA829896__INCLUDED_)
