// FileEditorDlg.h : Header-Datei
//

#if !defined(AFX_FILEEDITORDLG_H__371601E4_36B4_11D5_AF7E_0050DA829896__INCLUDED_)
#define AFX_FILEEDITORDLG_H__371601E4_36B4_11D5_AF7E_0050DA829896__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileInformation.h"


/////////////////////////////////////////////////////////////////////////////
// CFileEditorDlg Dialogfeld

class CFileEditorDlg : public CDialog
{
// Konstruktion
public:
	afx_msg void OnDropFiles(HDROP dropInfo);
	void Open(CString fullPath);
	CFileEditorDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CFileEditorDlg)
	enum { IDD = IDD_FILEEDITOR_DIALOG };
	BOOL	isArchive;
	CTime	accessDate;
	CTime	accessTime;
	CTime	changedDate;
	CTime	changedTime;
	CTime	createDate;
	CTime	createTime;
	CString	filename;
	CString	filePath;
	BOOL	isHidden;
	BOOL	isReadOnly;
	BOOL	isSystem;
	CString	fileSize;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CFileEditorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	void Update();
	HICON m_hIcon;
	CFileInformation file;
	bool initialized;
	bool commandLine;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CFileEditorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnIconClick();
	afx_msg void OnOpenFile();
	afx_msg void OnOK();
	afx_msg void OnSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_FILEEDITORDLG_H__371601E4_36B4_11D5_AF7E_0050DA829896__INCLUDED_)
